/*
----------------------------------------------------------------------

	AdAstra - Real Time Kernel

	Alain Chebrou

	cppentry.cpp		The entry point for C++ applications.
						Called from userInitTask()

	When		Who	What
	16/05/20	ac	Creation

	The C++ compiler mandatory flag : -fno-use-cxa-atexit
	The recommended flags           : -fno-exceptions -fno-non-call-exceptions -fno-rtti
	A good text with valuable links : https://bitbashing.io/embedded-cpp.html

----------------------------------------------------------------------
*/

#include	"aa.h"

//--------------------------------------------------------------------------------
// This is a simple C++ test
// You should delete this section to write your own code

#include	"aaprintf.h"

class  date_c
{
	uint32_t	day ;
	uint32_t	month ;
	uint32_t	year ;

public:
	date_c		(void)
	{
		day   = 1 ;
		month = 01 ;
		year  = 1970 ;
	}
	date_c		(uint32_t day, uint32_t month, uint32_t year)
	{
		this->day   = day ;
		this->month = month ;
		this->year  = year ;
	}

	virtual ~date_c (void) { }

	void	setDay		(uint32_t day)		{ this->day   = day ; }
	void	setMonth	(uint32_t month)	{ this->month = month ; }
	void	setYear		(uint32_t year)		{ this->year   = year ; }

	virtual void	print (void)
	{
		aaPrintf ("%02u/%02u/%04u\n", day, month, year) ;
	}
};

date_c	gDate ;

date_c	iDate (9, 9, 1999) ;


void	cppTest ()
{
	date_c	* pDate ;

	pDate = new date_c ;

	pDate->setDay (3) ;
	pDate->setMonth (5) ;
	pDate->setYear (2020) ;

	pDate->print () ;

	delete pDate ;


	gDate.setDay (2) ;
	gDate.setMonth (2) ;
	gDate.setYear (2002) ;

	gDate.print () ;

	iDate.print () ;
}

//--------------------------------------------------------------------------------
//--------------------------------------------------------------------------------

extern "C" void cppEntry (uintptr_t arg)
{
	// Delete these lines and insert your C++ code here
	(void) arg ;
	cppTest () ;
}

//--------------------------------------------------------------------------------
