/*
----------------------------------------------------------------------
	
	Alain Chebrou

	Spartan RT kernel

	bsp.h	Target specific "C" and "asm" routines

	When		Who	What
	30/12/13	ac	Creation

	This file contain functions declarations definitions and typedef for use by applications
----------------------------------------------------------------------
*/

#if ! defined AA_BSP_H_
#define AA_BSP_H_
//--------------------------------------------------------------------------------

#define	INLINE				_inline

typedef	uint32_t			bspBaseType ;		// Natural word size of the processor arch
typedef uintptr_t			bspStackType_t ;	// Size of stack words. For windows we put a HANDLE in the stack

//--------------------------------------------------------------------------------
// Some useful GCC compiler intrinsics (not intrinsics in WIN32)

#include <stdarg.h>
#include <ctype.h>
#include <string.h>
#define	aaVA_LIST	va_list
#define	aaVA_START	va_start
#define	aaVA_END	va_end
#define	aaVA_ARG	va_arg
#define	aaISDIGIT	isdigit
#define	aaSTRLEN	strlen
#define	aaSTRCMP	strcmp
#define	aaMEMCPY	memcpy

//--------------------------------------------------------------------------------
//--------------------------------------------------------------------------------
// Public BSP functions for application use

#ifdef __cplusplus
extern "C" {
#endif
//--------------------------------------------------------------------------------
//--------------------------------------------------------------------------------
// Public BSP functions for application use

uint32_t		bspGetTickRate			(void) ;
uint8_t			bspSetTickRate			(uint32_t tickRateHz) ;
uint32_t		bspGetSysClock 			(void) ;

void			bspPutChar				(char cc) ;

// Generic board specific I/O
void			bspBoardInit			(void) ;
uint32_t		bspInput				(uint32_t num) ;
void			bspLed					(uint32_t num, uint32_t state) ;
void			bspOutput				(uint32_t num, uint32_t state) ;

//--------------------------------------------------------------------------------
//--------------------------------------------------------------------------------
#ifdef __cplusplus
}
#endif
//--------------------------------------------------------------------------------
#endif	// AA_BSP_H_
