/*
----------------------------------------------------------------------

	AdAstra - Real Time Kernel

	Alain Chebrou

	bspboard.h	Defines GPIO to be configured by the BSP
				The definitions allows to use the BSP functions: bspOutput(), bspToggleOutput(), bspInput()

	When		Who	What
	10/06/17	ac	Creation
	13/05/20	ac	Add BSP_xxxn_ATTR

----------------------------------------------------------------------
*/

#if ! defined AABSPBOARD_H_
#define AABSPBOARD_H_
//--------------------------------------------------------------------------------
//	Fast access to some I/O pins
//	Don't change theses macros

#define	BSP_IO_GPIO(portNumber)				((GPIO_TypeDef *)(GPIOA_BASE + (GPIOB_BASE-GPIOA_BASE)*(portNumber)))
#define	BSP_MAKE_IO(portNumber, pinNumber)	((portNumber) << 4 | (pinNumber))


//--------------------------------------------------------------------------------
//	Here the user defines the pins that should be configured by bspBoardInit() in bspboard.c

// For each I/O an optional attribute can be added. Example
// #define	BSP_BUTTON0_ATTR			(AA_GPIO_PULL_UP)
// #define	BSP_OUTPUT0_ATTR			(AA_GPIO_OPEN_DRAIN | AA_GPIO_PULL_UP)

// Theses pins are for STM32F103RB NUCLEO board
// Green LED PA5
#define BSP_LED0_PORT_NUMBER		(0)	// Port A
#define BSP_LED0_PIN_NUMBER			(5)
#define	BSP_LED0					(BSP_MAKE_IO(BSP_LED0_PORT_NUMBER, BSP_LED0_PIN_NUMBER))
#define	BSP_LED0_ON					(1)
#define	BSP_LED0_OFF				(0)

// User button PC13
#define BSP_BUTTON0_PORT_NUMBER		(2)	// Port C
#define BSP_BUTTON0_PIN_NUMBER		(13)
#define	BSP_BUTTON0					(BSP_MAKE_IO(BSP_BUTTON0_PORT_NUMBER, BSP_BUTTON0_PIN_NUMBER))
#define	BSP_BUTTON0_PRESSED			(0)

// User debug pin PB10
#define	BSP_OUTPUT0_PORT_NUMBER		(1)	// Port B
#define	BSP_OUTPUT0_PIN_NUMBER		(10)
#define	BSP_OUTPUT0					(BSP_MAKE_IO(BSP_OUTPUT0_PORT_NUMBER, BSP_OUTPUT0_PIN_NUMBER))

//--------------------------------------------------------------------------------
#endif // AABSPBOARD_H_
